brcm63xx: Fixed vlan packet leakage in preinit for known devices with a switch on...
authorDaniel Dickinson <crazycshore@gmail.com>
Sun, 30 May 2010 01:33:20 +0000 (01:33 +0000)
committerDaniel Dickinson <crazycshore@gmail.com>
Sun, 30 May 2010 01:33:20 +0000 (01:33 +0000)
SVN-Revision: 21629

target/linux/brcm63xx/base-files/lib/preinit/05_failsafe_config_switch_brcm63xx [new file with mode: 0644]
target/linux/brcm63xx/base-files/lib/preinit/05_init_interfaces_brcm63xx [new file with mode: 0644]
target/linux/brcm63xx/base-files/lib/preinit/15_set_preinit_interface_brcm63xx [new file with mode: 0644]
target/linux/brcm63xx/base-files/lib/preinit/20_failsafe_net_echo_brcm63xx [new file with mode: 0644]

diff --git a/target/linux/brcm63xx/base-files/lib/preinit/05_failsafe_config_switch_brcm63xx b/target/linux/brcm63xx/base-files/lib/preinit/05_failsafe_config_switch_brcm63xx
new file mode 100644 (file)
index 0000000..b9be96e
--- /dev/null
@@ -0,0 +1,15 @@
+#!/bin/sh
+
+failsafe_ip() {
+       [ -d /proc/switch/eth1 ] && [ "$ifname" = "eth1" ] && {
+               ifconfig eth1 0.0.0.0 down
+               echo "0 1 2 3 4 ${cpu_port:-5u*}" > /proc/switch/eth1/vlan/0/ports
+       }
+       
+       [ -n "$pi_ifname" ] && grep -q "$pi_ifname" /proc/net/dev && {
+               ifconfig $pi_ifname $pi_ip netmask $pi_netmask broadcast $pi_broadcast up
+        }
+}
+
+boot_hook_add failsafe failsafe_ip
+
diff --git a/target/linux/brcm63xx/base-files/lib/preinit/05_init_interfaces_brcm63xx b/target/linux/brcm63xx/base-files/lib/preinit/05_init_interfaces_brcm63xx
new file mode 100644 (file)
index 0000000..b7cbecd
--- /dev/null
@@ -0,0 +1,26 @@
+#!/bin/sh
+
+set_preinit_iface() {
+       ifname=eth1
+
+       . /lib/brcm63xx.sh      
+
+       ifconfig $ifname 0.0.0.0 up
+}
+
+check_module () {
+  module="$1"; shift; params="$*"
+
+  insmod "$module" "$params"
+  sleep 1
+  grep "^$module" /proc/modules
+  return $?
+}
+
+init_iface() {
+       insmod switch-core
+       check_module switch-robo || check_module switch-adm || rmmod switch-core
+}
+
+boot_hook_add preinit_main set_preinit_iface
+boot_hook_add preinit_main init_iface
diff --git a/target/linux/brcm63xx/base-files/lib/preinit/15_set_preinit_interface_brcm63xx b/target/linux/brcm63xx/base-files/lib/preinit/15_set_preinit_interface_brcm63xx
new file mode 100644 (file)
index 0000000..6c7a8a8
--- /dev/null
@@ -0,0 +1,44 @@
+#!/bin/sh
+
+port_net_echo() {
+       [ -n "$pi_ifname" ] && grep -q "$pi_ifname" /proc/net/dev && {
+               if [ "$pi_preinit_net_messages" = "y" ] || [ "$pi_failsafe_net_message" = "true" ] && [ "$pi_preinit_no_failsafe_netmsg" != "y" ]; then 
+                       netmsg $pi_broadcast "$1"
+               fi
+       }
+}
+
+preinit_ip_deconfig() {
+       if [ -z "$pi_ifname" ]; then
+               ifconfig $ifname 0.0.0.0 down
+       else
+               grep -q "$pi_ifname" /proc/net/dev && {
+                       ifconfig $pi_ifname 0.0.0.0 down
+               }
+       fi
+       [ -d /proc/switch/eth1 ] && [ "$ifname" = "eth1" ] && {
+               echo 1 >/proc/switch/eth1/reset
+               echo "0 1 2 3 4 ${cpu_port:-5u*}" > /proc/switch/eth1/vlan/0/ports
+       }
+
+}
+
+preinit_net_echo() {
+       preinit_ip
+       
+       [ -d /proc/switch/eth1 ] && [ "$ifname" = "eth1" ] && {
+               echo 1 >/proc/switch/eth1/reset
+
+               # this would be easier if we blasted the message across all ports
+               # but we don't want packets leaking across interfaces
+               for port in $(seq 0 4); do {
+                       echo "$port ${cpu_port:-5u*}" > /proc/switch/eth1/vlan/0/ports
+                       port_net_echo $1
+               }; done
+               
+               echo "0 ${cpu_port:-5u*}" > /proc/switch/eth1/vlan/0/ports
+               
+       } || port_net_echo $1
+}
+
+
diff --git a/target/linux/brcm63xx/base-files/lib/preinit/20_failsafe_net_echo_brcm63xx b/target/linux/brcm63xx/base-files/lib/preinit/20_failsafe_net_echo_brcm63xx
new file mode 100644 (file)
index 0000000..f030cb2
--- /dev/null
@@ -0,0 +1,12 @@
+#!/bin/sh
+
+indicate_failsafe() {
+       preinit_net_echo() {
+               port_net_echo $1
+       }
+       echo "- failsafe -"
+       preinit_net_echo "Entering Failsafe!\n"
+       indicate_failsafe_led
+}
+
+